
import sys, os, struct
from machine_config import *

#################################################################
# This is GPL software.
# Written by noggie
#################################################################

verbose = 0
def set_verbose():
  global verbose
  verbose = 1

# Verbose print
def vprint(fmt, *args):
  if verbose:
    sys.stderr.write(fmt % args)

# Exit script
def die(fmt, *args):
  sys.stderr.write(fmt % args)
  sys.exit(1)

# Compute pad length
def pad(x, y):
  return (y - 1) - ((x + y - 1) % y)

def sudo(*cmd):
  vprint('sudo ' + ' '.join(cmd) + '\n')
  return os.system('sudo ' + ' '.join(cmd))

def mount_root():
  return sudo('mount', ROOT_DEV, ROOT_PT)

def mount_boot():
  return sudo('mount', BOOT_DEV, BOOT_PT)

def umount_root():
  return sudo('umount', ROOT_PT)

def umount_boot():
  return sudo('umount', BOOT_PT)

# Try to make this procedure re-usable
# nfi file on stdin, all outfiles by name
# use /dev/null as output name if the partition should be skipped
def extract_nfi(outfiles):
  i = 1
  for n in outfiles:
    vprint("File %d : %s\n", i, n)
    i += 1

  buf = sys.stdin.read(4)
  if buf == 'NFI1':
    buf = sys.stdin.read(28);
    vprint("New format: %s\n", buf)
    buf = sys.stdin.read(4)

  size_part_table = struct.unpack('!I', sys.stdin.read(4))[0]
  if (size_part_table / 4) != len(outfiles):
    die('Number of partitions (%d) != number of output files (%d)' % ((size_part_table / 4), len(outfiles)))
  sys.stdin.read(size_part_table) # read and discard

  for n in outfiles:
    part_size = struct.unpack('!I', sys.stdin.read(4))[0]
    pad_size = pad(part_size, 16 * 1024)
    f = open(n, 'w')
    while part_size > 0:
      buf = sys.stdin.read(528)
      f.write(buf[0:512])
      part_size -= 528
    # Pad to erasesz
    f.write('\xFF' * pad_size)
